Index: /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90
===================================================================
--- /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5192)
+++ /LMDZ6/branches/Amaury_dev/libf/phylmd/lmdz_wake.F90	(revision 5193)
@@ -1843,630 +2066,394 @@
           d_asigmaw2(i) = d_asigmaw2(i) + sigmaw_targ - asigmaw(i)
           asigmaw(i) = sigmaw_targ
-!>jyg
+          !>jyg
           fip(i) = 0.
           gwake(i) = .FALSE.
         ELSE
-          cstar(i) = stark*sqrt(2.*wape(i))
+          IF (prt_level>=10) PRINT *, 'wape2>0'
+          cstar2(i) = stark * sqrt(2. * wape2(i))
           gwake(i) = .TRUE.
         END IF
-      END IF
-    END DO
-
-  ! ------------------------------------------------------------------------
-
-  END DO   ! isubstep end sub-timestep loop
-
-  ! ------------------------------------------------------------------------
-  ! ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
-  ! ------------------------------------------------------------------------
-
-#ifdef IOPHYS_WK
-    IF (.NOT.phys_sub) CALL iophys_ecrit('wape_b',1,'wape_b','J/kg',wape)
-#endif
-  IF (prt_level>=10) THEN
-    PRINT *, 'wake-5, sigmaw(igout), cstar(igout), wape(igout), ptop(igout) ', &
-                      sigmaw(igout), cstar(igout), wape(igout), ptop(igout)
-  ENDIF
-
-
-  ! ----------------------------------------------------------
-  ! Determine wake final state; recompute wape, cstar, ktop;
-  ! filter out bad wakes.
-  ! ----------------------------------------------------------
-
-  ! 2.1 - Undisturbed area and Wake integrals
-  ! ---------------------------------------------------------
-
-  DO i = 1, klon
-    ! cc nrlmd       if (wk_adv(i)) then !!! nrlmd
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      z(i) = 0.
-      sum_thx(i) = 0.
-      sum_tx(i) = 0.
-      sum_qx(i) = 0.
-      sum_thvx(i) = 0.
-      sum_dth(i) = 0.
-      sum_half_dth(i) = 0.
-      sum_dq(i) = 0.
-      sum_dtdwn(i) = 0.
-      sum_dqdwn(i) = 0.
-
-      av_thx(i) = 0.
-      av_tx(i) = 0.
-      av_qx(i) = 0.
-      av_thvx(i) = 0.
-      av_dth(i) = 0.
-      av_dq(i) = 0.
-      av_dtdwn(i) = 0.
-      av_dqdwn(i) = 0.
-
-      dthmin(i) = -delta_t_min
-    END IF
-  END DO
-  ! Potential temperatures and humidity
-  ! ----------------------------------------------------------
-
-  DO k = 1, klev
+        IF (CPPKEY_IOPHYS_WK) THEN
+          IF (.NOT.phys_sub) CALL iophys_ecrit('cstar2', 1, 'cstar2', 'J/kg', cstar2)
+        END IF
+      END IF  ! (ok_qx_qw(i))
+    END DO
+
     DO i = 1, klon
       ! cc nrlmd       IF ( wk_adv(i)) THEN
       IF (ok_qx_qw(i)) THEN
         ! cc
-        rho(i, k) = p(i, k)/(RD*tb(i,k))
-        IF (k==1) THEN
-          rhoh(i, k) = ph(i, k)/(RD*tb(i,k))
-          zhh(i, k) = 0
-        ELSE
-          rhoh(i, k) = ph(i, k)*2./(RD*(tb(i,k)+tb(i,k-1)))
-          zhh(i, k) = (ph(i,k)-ph(i,k-1))/(-rhoh(i,k)*RG) + zhh(i, k-1)
-        END IF
-        thb(i, k) = tb(i, k)/ppi(i, k)
-        thx(i, k) = (tb(i,k)-deltatw(i,k)*sigmaw(i))/ppi(i, k)
-        tx(i, k) = tb(i, k) - deltatw(i, k)*sigmaw(i)
-        qx(i, k) = qb(i, k) - deltaqw(i, k)*sigmaw(i)
-        dth(i, k) = deltatw(i, k)/ppi(i, k)
+        ktopw(i) = ktop(i)
       END IF
     END DO
-  END DO
-
-  ! Integrals (and wake top level number)
-  ! -----------------------------------------------------------
-
-  ! Initialize sum_thvx to 1st level virt. pot. temp.
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      z(i) = 1.
-      dz(i) = 1.
-      dz_half(i) = 1.
-      sum_thvx(i) = thx(i, 1)*(1.+epsim1*qx(i,1))*dz(i)
-      sum_dth(i) = 0.
-    END IF
-  END DO
-
-  DO k = 1, klev
+
     DO i = 1, klon
       ! cc nrlmd       IF ( wk_adv(i)) THEN
       IF (ok_qx_qw(i)) THEN
         ! cc
-        dz(i) = -(amax1(ph(i,k+1),ptop(i))-ph(i,k))/(rho(i,k)*RG)
-        dz_half(i) = -(amax1(ph(i,k+1),0.5*(ptop(i)+ph(i,1)))-ph(i,k))/(rho(i,k)*RG)
-        IF (dz(i)>0) THEN
-          z(i) = z(i) + dz(i)
-          sum_thx(i) = sum_thx(i) + thx(i, k)*dz(i)
-          sum_tx(i) = sum_tx(i) + tx(i, k)*dz(i)
-          sum_qx(i) = sum_qx(i) + qx(i, k)*dz(i)
-          sum_thvx(i) = sum_thvx(i) + thx(i, k)*(1.+epsim1*qx(i,k))*dz(i)
-          sum_dth(i) = sum_dth(i) + dth(i, k)*dz(i)
-          sum_dq(i) = sum_dq(i) + deltaqw(i, k)*dz(i)
-          sum_dtdwn(i) = sum_dtdwn(i) + dtdwn(i, k)*dz(i)
-          sum_dqdwn(i) = sum_dqdwn(i) + dqdwn(i, k)*dz(i)
-
-          dthmin(i) = min(dthmin(i), dth(i,k))
-        END IF
-        IF (dz_half(i)>0) THEN
-          sum_half_dth(i) = sum_half_dth(i) + dth(i, k)*dz_half(i)
+        IF (ktopw(i)>0 .AND. gwake(i)) THEN
+
+          ! jyg1     Utilisation d'un h_efficace constant ( ~ feeding layer)
+          ! cc       heff = 600.
+          ! Utilisation de la hauteur hw
+          ! c       heff = 0.7*hw
+          heff(i) = hw(i)
+
+          fip(i) = 0.5 * rho(i, ktopw(i)) * cstar2(i)**3 * heff(i) * 2 * &
+                  sqrt(sigmaw(i) * wdens(i) * 3.14)
+          fip(i) = alpk * fip(i)
+          ! jyg2
+        ELSE
+          fip(i) = 0.
         END IF
       END IF
     END DO
-  END DO
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      hw0(i) = z(i)
+    IF (iflag_wk_pop_dyn >= 3) THEN
+      IF (CPPKEY_IOPHYS_WK) THEN
+        IF (.NOT.phys_sub) THEN
+          CALL iophys_ecrit('fip', 1, 'fip', 'J/kg', fip)
+          CALL iophys_ecrit('hw', 1, 'hw', 'J/kg', hw)
+          CALL iophys_ecrit('ptop', 1, 'ptop', 'J/kg', ptop)
+          CALL iophys_ecrit('wdens', 1, 'wdens', 'J/kg', wdens)
+          CALL iophys_ecrit('awdens', 1, 'awdens', 'm', awdens)
+          CALL iophys_ecrit('sigmaw', 1, 'sigmaw', 'm', sigmaw)
+          CALL iophys_ecrit('asigmaw', 1, 'asigmaw', 'm', asigmaw)
+
+          CALL iophys_ecrit('rad_wk', 1, 'rad_wk', 'J/kg', rad_wk)
+          CALL iophys_ecrit('arad_wk', 1, 'arad_wk', 'J/kg', arad_wk)
+          CALL iophys_ecrit('irad_wk', 1, 'irad_wk', 'J/kg', irad_wk)
+
+          CALL iophys_ecrit('d_wdens2', 1, 'd_wdens2', '', d_wdens2)
+          CALL iophys_ecrit('d_dens_gen2', 1, 'd_dens_gen2', '', d_dens_gen2)
+          CALL iophys_ecrit('d_dens_death2', 1, 'd_dens_death2', '', d_dens_death2)
+          CALL iophys_ecrit('d_dens_col2', 1, 'd_dens_col2', '', d_dens_col2)
+          CALL iophys_ecrit('d_dens_bnd2', 1, 'd_dens_bnd2', '', d_dens_bnd2)
+
+          CALL iophys_ecrit('d_awdens2', 1, 'd_awdens2', '', d_awdens2)
+          CALL iophys_ecrit('d_adens_death2', 1, 'd_adens_death2', '', d_adens_death2)
+          CALL iophys_ecrit('d_adens_icol2', 1, 'd_adens_icol2', '', d_adens_icol2)
+          CALL iophys_ecrit('d_adens_acol2', 1, 'd_adens_acol2', '', d_adens_acol2)
+          CALL iophys_ecrit('d_adens_bnd2', 1, 'd_adens_bnd2', '', d_adens_bnd2)
+
+          CALL iophys_ecrit('d_sigmaw2', 1, 'd_sigmaw2', '', d_sigmaw2)
+          CALL iophys_ecrit('d_sig_gen2', 1, 'd_sig_gen2', 'm', d_sig_gen2)
+          CALL iophys_ecrit('d_sig_spread2', 1, 'd_sig_spread2', '', d_sig_spread2)
+          CALL iophys_ecrit('d_sig_col2', 1, 'd_sig_col2', '', d_sig_col2)
+          CALL iophys_ecrit('d_sig_death2', 1, 'd_sig_death2', '', d_sig_death2)
+          CALL iophys_ecrit('d_sig_bnd2', 1, 'd_sig_bnd2', '', d_sig_bnd2)
+
+          CALL iophys_ecrit('d_asigmaw2', 1, 'd_asigmaw2', '', d_asigmaw2)
+          CALL iophys_ecrit('d_asig_spread2', 1, 'd_asig_spread2', 'm', d_asig_spread2)
+          CALL iophys_ecrit('d_asig_aicol2', 1, 'd_asig_aicol2', 'm', d_asig_aicol2)
+          CALL iophys_ecrit('d_asig_iicol2', 1, 'd_asig_iicol2', 'm', d_asig_iicol2)
+          CALL iophys_ecrit('d_asig_death2', 1, 'd_asig_death2', 'm', d_asig_death2)
+          CALL iophys_ecrit('d_asig_bnd2', 1, 'd_asig_bnd2', 'm', d_asig_bnd2)
+        ENDIF  ! (.NOT.phys_sub)
+      END IF
+    ENDIF  ! (iflag_wk_pop_dyn >= 3)
+    ! Limitation de sigmaw
+
+    ! cc nrlmd
+    ! DO i=1,klon
+    ! IF (OK_qx_qw(i)) THEN
+    ! IF (sigmaw(i).GE.sigmaw_max) sigmaw(i)=sigmaw_max
+    ! ENDIF
+    ! ENDDO
+    ! cc
+
+    !jyg<
+    IF (iflag_wk_pop_dyn >= 1) THEN
+      DO i = 1, klon
+        kill_wake(i) = ((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
+                .NOT. ok_qx_qw(i) .OR. (wdens(i) < wdensthreshold)
+        !!          .NOT. ok_qx_qw(i) .OR. (wdens(i) < 2.*wdensmin)
+      ENDDO
+    ELSE  ! (iflag_wk_pop_dyn >= 1)
+      DO i = 1, klon
+        kill_wake(i) = ((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
+                .NOT. ok_qx_qw(i)
+      ENDDO
+    ENDIF  ! (iflag_wk_pop_dyn >= 1)
+    !>jyg
+
+    DO k = 1, klev
+      DO i = 1, klon
+        !!jyg      IF (((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
+        !!jyg          .NOT. ok_qx_qw(i)) THEN
+        IF (kill_wake(i)) THEN
+          ! cc
+          dtls(i, k) = 0.
+          dqls(i, k) = 0.
+          deltatw(i, k) = 0.
+          deltaqw(i, k) = 0.
+          d_deltatw2(i, k) = -deltatw0(i, k)
+          d_deltaqw2(i, k) = -deltaqw0(i, k)
+        END IF  ! (kill_wake(i))
+      END DO
+    END DO
+
+    DO i = 1, klon
+      !!jyg    IF (((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
+      !!jyg        .NOT. ok_qx_qw(i)) THEN
+      IF (kill_wake(i)) THEN
+        ktopw(i) = 0
+        wape(i) = 0.
+        cstar(i) = 0.
+        !!jyg   Outside SUBROUTINE "Wake" hw, wdens sigmaw and asigmaw are zero when there are no wakes
+        !!      hw(i) = hwmin                       !jyg
+        !!      sigmaw(i) = sigmad                  !jyg
+        hw(i) = 0.                            !jyg
+        fip(i) = 0.
+
+        !!      sigmaw(i) = 0.                        !jyg
+        sigmaw_targ = 0.
+        d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
+        !!      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+        d_sigmaw2(i) = sigmaw_targ - sigmaw_in(i)      ! _in = correction jyg 20220124
+        sigmaw(i) = sigmaw_targ
+
+        IF (iflag_wk_pop_dyn >= 3) THEN
+          sigmaw_targ = 0.
+          d_asig_bnd2(i) = d_asig_bnd2(i) + sigmaw_targ - asigmaw(i)
+          !!        d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+          d_asigmaw2(i) = sigmaw_targ - asigmaw_in(i)      ! _in = correction jyg 20220124
+          asigmaw(i) = sigmaw_targ
+        ELSE
+          asigmaw(i) = 0.
+        ENDIF ! (iflag_wk_pop_dyn >= 3)
+
+        IF (iflag_wk_pop_dyn >= 1) THEN
+          !!        awdens(i) = 0.
+          !!        wdens(i) = 0.
+          wdens_targ = 0.
+          d_dens_bnd2(i) = d_dens_bnd2(i) + wdens_targ - wdens(i)
+          !!        d_wdens2(i) = wdens_targ - wdens(i)
+          d_wdens2(i) = wdens_targ - wdens_in(i)      ! jyg 20220916
+          wdens(i) = wdens_targ
+          wdens_targ = 0.
+          !!jyg: bug fix : the d_adens_bnd2 computation must be before the update of awdens.
+          IF (iflag_wk_pop_dyn >= 2) THEN
+            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
+          ENDIF ! (iflag_wk_pop_dyn >= 2)
+          !!        d_awdens2(i) = wdens_targ - awdens(i)
+          d_awdens2(i) = wdens_targ - awdens_in(i)    ! jyg 20220916
+          awdens(i) = wdens_targ
+          !!        IF (iflag_wk_pop_dyn == 2) THEN
+          !!            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
+          !!        ENDIF ! (iflag_wk_pop_dyn == 2)
+        ENDIF  ! (iflag_wk_pop_dyn >= 1)
+      ELSE  ! (kill_wake(i))
+        wape(i) = wape2(i)
+        cstar(i) = cstar2(i)
+      END IF  ! (kill_wake(i))
+      ! c        PRINT*,'wape wape2 ktopw OK_qx_qw =',
+      ! c     $          wape(i),wape2(i),ktopw(i),OK_qx_qw(i)
+    END DO
+
+    IF (prt_level>=10) THEN
+      PRINT *, 'wake-6, wape wape2 ktopw OK_qx_qw =', &
+              wape(igout), wape2(igout), ktopw(igout), OK_qx_qw(igout)
+    ENDIF
+    IF (CPPKEY_IOPHYS_WK) THEN
+      IF (.NOT.phys_sub) CALL iophys_ecrit('wape_c', 1, 'wape_c', 'J/kg', wape)
     END IF
-  END DO
-
-  ! - WAPE and mean forcing computation
-  ! -------------------------------------------------------------
-
-  ! Means
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      av_thx(i) = sum_thx(i)/hw0(i)
-      av_tx(i) = sum_tx(i)/hw0(i)
-      av_qx(i) = sum_qx(i)/hw0(i)
-      av_thvx(i) = sum_thvx(i)/hw0(i)
-      av_dth(i) = sum_dth(i)/hw0(i)
-      av_dq(i) = sum_dq(i)/hw0(i)
-      av_dtdwn(i) = sum_dtdwn(i)/hw0(i)
-      av_dqdwn(i) = sum_dqdwn(i)/hw0(i)
-
-      wape2(i) = -RG*hw0(i)*(av_dth(i)+epsim1*(av_thx(i)*av_dq(i) + &
-                             av_dth(i)*av_qx(i)+av_dth(i)*av_dq(i)))/av_thvx(i)
-    END IF
-  END DO
-#ifdef IOPHYS_WK
-  IF (.NOT.phys_sub) CALL iophys_ecrit('wape2_a',1,'wape2_a','J/kg',wape2)
-#endif
-
-
-  ! Prognostic variable update
-  ! ------------------------------------------------------------
-
-  ! Filter out bad wakes
-
-  IF (iflag_wk_check_trgl>=1) THEN
-    ! Check triangular shape of dth profile
-    DO i = 1, klon
-      IF (ok_qx_qw(i)) THEN
-        !! PRINT *,'wake, hw0(i), dthmin(i) ', hw0(i), dthmin(i)
-        !! PRINT *,'wake, 2.*sum_dth(i)/(hw0(i)*dthmin(i)) ', &
-        !!                2.*sum_dth(i)/(hw0(i)*dthmin(i))
-        !! PRINT *,'wake, sum_half_dth(i), sum_dth(i) ', &
-        !!                sum_half_dth(i), sum_dth(i)
-        IF ((hw0(i) < 1.) .OR. (dthmin(i) >= -delta_t_min) ) THEN
-          wape2(i) = -1.
-          !! PRINT *,'wake, rej 1'
-        ELSE IF (iflag_wk_check_trgl==1.AND.abs(2.*sum_dth(i)/(hw0(i)*dthmin(i)) - 1.) > 0.5) THEN
-          wape2(i) = -1.
-          !! PRINT *,'wake, rej 2'
-        ELSE IF (abs(sum_half_dth(i)) < 0.5*abs(sum_dth(i)) ) THEN
-          wape2(i) = -1.
-          !! PRINT *,'wake, rej 3'
-        END IF
-      END IF
-    END DO
-  END IF
-#ifdef IOPHYS_WK
-  IF (.NOT.phys_sub) CALL iophys_ecrit('wape2_b',1,'wape2_b','J/kg',wape2)
-#endif
-
-
-  DO k = 1, klev
-    DO i = 1, klon
-      ! cc nrlmd        IF ( wk_adv(i) .AND. wape2(i) .LT. 0.) THEN
-      IF (ok_qx_qw(i) .AND. wape2(i)<0.) THEN
-        ! cc
-        deltatw(i, k) = 0.
-        deltaqw(i, k) = 0.
-        dth(i, k) = 0.
-        d_deltatw2(i,k) = -deltatw0(i,k)
-        d_deltaqw2(i,k) = -deltaqw0(i,k)
-      END IF
-    END DO
-  END DO
-
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      IF (wape2(i)<0.) THEN
-        wape2(i) = 0.
-        cstar2(i) = 0.
-        hw(i) = hwmin
-!jyg<
-!!      sigmaw(i) = amax1(sigmad, sigd_con(i))
-      sigmaw_targ = max(sigmad, sigd_con(i))
-      d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
-      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
-      sigmaw(i) = sigmaw_targ
-
-      d_asig_bnd2(i) = d_asig_bnd2(i) + sigmaw_targ - asigmaw(i)
-      d_asigmaw2(i) = d_asigmaw2(i) + sigmaw_targ - asigmaw(i)
-      asigmaw(i) = sigmaw_targ
-!>jyg
-        fip(i) = 0.
-        gwake(i) = .FALSE.
-      ELSE
-        IF (prt_level>=10) PRINT *, 'wape2>0'
-        cstar2(i) = stark*sqrt(2.*wape2(i))
-        gwake(i) = .TRUE.
-      END IF
-#ifdef IOPHYS_WK
-  IF (.NOT.phys_sub) CALL iophys_ecrit('cstar2',1,'cstar2','J/kg',cstar2)
-#endif
-    END IF  ! (ok_qx_qw(i))
-  END DO
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      ktopw(i) = ktop(i)
-    END IF
-  END DO
-
-  DO i = 1, klon
-    ! cc nrlmd       IF ( wk_adv(i)) THEN
-    IF (ok_qx_qw(i)) THEN
-      ! cc
-      IF (ktopw(i)>0 .AND. gwake(i)) THEN
-
-        ! jyg1     Utilisation d'un h_efficace constant ( ~ feeding layer)
-        ! cc       heff = 600.
-        ! Utilisation de la hauteur hw
-        ! c       heff = 0.7*hw
-        heff(i) = hw(i)
-
-        fip(i) = 0.5*rho(i, ktopw(i))*cstar2(i)**3*heff(i)*2* &
-          sqrt(sigmaw(i)*wdens(i)*3.14)
-        fip(i) = alpk*fip(i)
-        ! jyg2
-      ELSE
-        fip(i) = 0.
-      END IF
-    END IF
-  END DO
-    IF (iflag_wk_pop_dyn >= 3) THEN
-#ifdef IOPHYS_WK
-      IF (.NOT.phys_sub) THEN
-       CALL iophys_ecrit('fip',1,'fip','J/kg',fip)
-       CALL iophys_ecrit('hw',1,'hw','J/kg',hw)
-       CALL iophys_ecrit('ptop',1,'ptop','J/kg',ptop)
-       CALL iophys_ecrit('wdens',1,'wdens','J/kg',wdens)
-       CALL iophys_ecrit('awdens',1,'awdens','m',awdens)
-       CALL iophys_ecrit('sigmaw',1,'sigmaw','m',sigmaw)
-       CALL iophys_ecrit('asigmaw',1,'asigmaw','m',asigmaw)
-
-       CALL iophys_ecrit('rad_wk',1,'rad_wk','J/kg',rad_wk)
-       CALL iophys_ecrit('arad_wk',1,'arad_wk','J/kg',arad_wk)
-       CALL iophys_ecrit('irad_wk',1,'irad_wk','J/kg',irad_wk)
-
-       CALL iophys_ecrit('d_wdens2',1,'d_wdens2','',d_wdens2)
-       CALL iophys_ecrit('d_dens_gen2',1,'d_dens_gen2','',d_dens_gen2)
-       CALL iophys_ecrit('d_dens_death2',1,'d_dens_death2','',d_dens_death2)
-       CALL iophys_ecrit('d_dens_col2',1,'d_dens_col2','',d_dens_col2)
-       CALL iophys_ecrit('d_dens_bnd2',1,'d_dens_bnd2','',d_dens_bnd2)
-
-       CALL iophys_ecrit('d_awdens2',1,'d_awdens2','',d_awdens2)
-       CALL iophys_ecrit('d_adens_death2',1,'d_adens_death2','',d_adens_death2)
-       CALL iophys_ecrit('d_adens_icol2',1,'d_adens_icol2','',d_adens_icol2)
-       CALL iophys_ecrit('d_adens_acol2',1,'d_adens_acol2','',d_adens_acol2)
-       CALL iophys_ecrit('d_adens_bnd2',1,'d_adens_bnd2','',d_adens_bnd2)
-
-       CALL iophys_ecrit('d_sigmaw2',1,'d_sigmaw2','',d_sigmaw2)
-       CALL iophys_ecrit('d_sig_gen2',1,'d_sig_gen2','m',d_sig_gen2)
-       CALL iophys_ecrit('d_sig_spread2',1,'d_sig_spread2','',d_sig_spread2)
-       CALL iophys_ecrit('d_sig_col2',1,'d_sig_col2','',d_sig_col2)
-       CALL iophys_ecrit('d_sig_death2',1,'d_sig_death2','',d_sig_death2)
-       CALL iophys_ecrit('d_sig_bnd2',1,'d_sig_bnd2','',d_sig_bnd2)
-
-       CALL iophys_ecrit('d_asigmaw2',1,'d_asigmaw2','',d_asigmaw2)
-       CALL iophys_ecrit('d_asig_spread2',1,'d_asig_spread2','m',d_asig_spread2)
-       CALL iophys_ecrit('d_asig_aicol2',1,'d_asig_aicol2','m',d_asig_aicol2)
-       CALL iophys_ecrit('d_asig_iicol2',1,'d_asig_iicol2','m',d_asig_iicol2)
-       CALL iophys_ecrit('d_asig_death2',1,'d_asig_death2','m',d_asig_death2)
-       CALL iophys_ecrit('d_asig_bnd2',1,'d_asig_bnd2','m',d_asig_bnd2)
-      ENDIF  ! (.NOT.phys_sub)
-#endif
-    ENDIF  ! (iflag_wk_pop_dyn >= 3)
-  ! Limitation de sigmaw
-
-  ! cc nrlmd
-  ! DO i=1,klon
-  ! IF (OK_qx_qw(i)) THEN
-  ! IF (sigmaw(i).GE.sigmaw_max) sigmaw(i)=sigmaw_max
-  ! ENDIF
-  ! ENDDO
-  ! cc
-
-  !jyg<
-  IF (iflag_wk_pop_dyn >= 1) THEN
-    DO i = 1, klon
-      kill_wake(i) = ((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
-          .NOT. ok_qx_qw(i) .OR. (wdens(i) < wdensthreshold)
-!!          .NOT. ok_qx_qw(i) .OR. (wdens(i) < 2.*wdensmin)
-    ENDDO
-  ELSE  ! (iflag_wk_pop_dyn >= 1)
-    DO i = 1, klon
-      kill_wake(i) = ((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
-          .NOT. ok_qx_qw(i)
-    ENDDO
-  ENDIF  ! (iflag_wk_pop_dyn >= 1)
-  !>jyg
-
-  DO k = 1, klev
-    DO i = 1, klon
-!!jyg      IF (((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
-!!jyg          .NOT. ok_qx_qw(i)) THEN
-      IF (kill_wake(i)) THEN
-        ! cc
-        dtls(i, k) = 0.
-        dqls(i, k) = 0.
-        deltatw(i, k) = 0.
-        deltaqw(i, k) = 0.
-        d_deltatw2(i,k) = -deltatw0(i,k)
-        d_deltaqw2(i,k) = -deltaqw0(i,k)
-      END IF  ! (kill_wake(i))
-    END DO
-  END DO
-
-  DO i = 1, klon
-!!jyg    IF (((wape(i)>=wape2(i)) .AND. (wape2(i)<=wapecut)) .OR. (ktopw(i)<=2) .OR. &
-!!jyg        .NOT. ok_qx_qw(i)) THEN
-      IF (kill_wake(i)) THEN
-      ktopw(i) = 0
-      wape(i) = 0.
-      cstar(i) = 0.
-!!jyg   Outside SUBROUTINE "Wake" hw, wdens sigmaw and asigmaw are zero when there are no wakes
-!!      hw(i) = hwmin                       !jyg
-!!      sigmaw(i) = sigmad                  !jyg
-      hw(i) = 0.                            !jyg
-      fip(i) = 0.
-
-!!      sigmaw(i) = 0.                        !jyg
-      sigmaw_targ = 0.
-      d_sig_bnd2(i) = d_sig_bnd2(i) + sigmaw_targ - sigmaw(i)
-!!      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
-      d_sigmaw2(i) = sigmaw_targ - sigmaw_in(i)      ! _in = correction jyg 20220124
-      sigmaw(i) = sigmaw_targ
-
-      IF (iflag_wk_pop_dyn >= 3) THEN
-        sigmaw_targ = 0.
-        d_asig_bnd2(i) = d_asig_bnd2(i) + sigmaw_targ - asigmaw(i)
-!!        d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
-        d_asigmaw2(i) = sigmaw_targ - asigmaw_in(i)      ! _in = correction jyg 20220124
-        asigmaw(i) = sigmaw_targ
-      ELSE
-        asigmaw(i) = 0.
-      ENDIF ! (iflag_wk_pop_dyn >= 3)
-
-      IF (iflag_wk_pop_dyn >= 1) THEN
-!!        awdens(i) = 0.
-!!        wdens(i) = 0.
-        wdens_targ = 0.
-        d_dens_bnd2(i) = d_dens_bnd2(i) + wdens_targ - wdens(i)
-!!        d_wdens2(i) = wdens_targ - wdens(i)
-        d_wdens2(i) = wdens_targ - wdens_in(i)      ! jyg 20220916
-        wdens(i) = wdens_targ
-        wdens_targ = 0.
-!!jyg: bug fix : the d_adens_bnd2 computation must be before the update of awdens.
-        IF (iflag_wk_pop_dyn >= 2) THEN
-            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
-        ENDIF ! (iflag_wk_pop_dyn >= 2)
-!!        d_awdens2(i) = wdens_targ - awdens(i)
-        d_awdens2(i) = wdens_targ - awdens_in(i)    ! jyg 20220916
-        awdens(i) = wdens_targ
-!!        IF (iflag_wk_pop_dyn == 2) THEN
-!!            d_adens_bnd2(i) = d_adens_bnd2(i) + wdens_targ - awdens(i)
-!!        ENDIF ! (iflag_wk_pop_dyn == 2)
-      ENDIF  ! (iflag_wk_pop_dyn >= 1)
-    ELSE  ! (kill_wake(i))
-      wape(i) = wape2(i)
-      cstar(i) = cstar2(i)
-    END IF  ! (kill_wake(i))
-    ! c        PRINT*,'wape wape2 ktopw OK_qx_qw =',
-    ! c     $          wape(i),wape2(i),ktopw(i),OK_qx_qw(i)
-  END DO
-
-  IF (prt_level>=10) THEN
-    PRINT *, 'wake-6, wape wape2 ktopw OK_qx_qw =', &
-                      wape(igout),wape2(igout),ktopw(igout),OK_qx_qw(igout)
-  ENDIF
-#ifdef IOPHYS_WK
-  IF (.NOT.phys_sub) CALL iophys_ecrit('wape_c',1,'wape_c','J/kg',wape)
-#endif
-
-
-  ! -----------------------------------------------------------------
-  ! Get back to tendencies per second
-
-  DO k = 1, klev
-    DO i = 1, klon
-
-      ! cc nrlmd        IF ( wk_adv(i) .AND. k .LE. kupper(i)) THEN
-!jyg<
-!!      IF (ok_qx_qw(i) .AND. k<=kupper(i)) THEN
-      IF (ok_qx_qw(i)) THEN
-!>jyg
-        ! cc
-        dtls(i, k) = dtls(i, k)/dtime
-        dqls(i, k) = dqls(i, k)/dtime
-        d_deltatw2(i, k) = d_deltatw2(i, k)/dtime
-        d_deltaqw2(i, k) = d_deltaqw2(i, k)/dtime
-        d_deltat_gw(i, k) = d_deltat_gw(i, k)/dtime
-        ! c      PRINT*,'k,dqls,omg,entr,detr',k,dqls(i,k),omg(i,k),entr(i,k)
-        ! c     $         ,death_rate(i)*sigmaw(i)
-      END IF
-    END DO
-  END DO
-!jyg<
-  IF (iflag_wk_pop_dyn >= 1) THEN
-    DO i = 1, klon
+
+
+    ! -----------------------------------------------------------------
+    ! Get back to tendencies per second
+
+    DO k = 1, klev
+      DO i = 1, klon
+
+        ! cc nrlmd        IF ( wk_adv(i) .AND. k .LE. kupper(i)) THEN
+        !jyg<
+        !!      IF (ok_qx_qw(i) .AND. k<=kupper(i)) THEN
         IF (ok_qx_qw(i)) THEN
-      d_sig_gen2(i) = d_sig_gen2(i)/dtime
-      d_sig_death2(i) = d_sig_death2(i)/dtime
-      d_sig_col2(i) = d_sig_col2(i)/dtime
-      d_sig_spread2(i) = d_sig_spread2(i)/dtime
-      d_sig_bnd2(i) = d_sig_bnd2(i)/dtime
-      d_sigmaw2(i) = d_sigmaw2(i)/dtime
-
-      d_dens_gen2(i) = d_dens_gen2(i)/dtime
-      d_dens_death2(i) = d_dens_death2(i)/dtime
-      d_dens_col2(i) = d_dens_col2(i)/dtime
-      d_dens_bnd2(i) = d_dens_bnd2(i)/dtime
-      d_awdens2(i) = d_awdens2(i)/dtime
-      d_wdens2(i) = d_wdens2(i)/dtime
-        ENDIF
-    ENDDO
-    IF (iflag_wk_pop_dyn >= 2) THEN
+          !>jyg
+          ! cc
+          dtls(i, k) = dtls(i, k) / dtime
+          dqls(i, k) = dqls(i, k) / dtime
+          d_deltatw2(i, k) = d_deltatw2(i, k) / dtime
+          d_deltaqw2(i, k) = d_deltaqw2(i, k) / dtime
+          d_deltat_gw(i, k) = d_deltat_gw(i, k) / dtime
+          ! c      PRINT*,'k,dqls,omg,entr,detr',k,dqls(i,k),omg(i,k),entr(i,k)
+          ! c     $         ,death_rate(i)*sigmaw(i)
+        END IF
+      END DO
+    END DO
+    !jyg<
+    IF (iflag_wk_pop_dyn >= 1) THEN
       DO i = 1, klon
         IF (ok_qx_qw(i)) THEN
-        d_adens_death2(i) = d_adens_death2(i)/dtime
-        d_adens_icol2(i) = d_adens_icol2(i)/dtime
-        d_adens_acol2(i) = d_adens_acol2(i)/dtime
-        d_adens_bnd2(i) = d_adens_bnd2(i)/dtime
+          d_sig_gen2(i) = d_sig_gen2(i) / dtime
+          d_sig_death2(i) = d_sig_death2(i) / dtime
+          d_sig_col2(i) = d_sig_col2(i) / dtime
+          d_sig_spread2(i) = d_sig_spread2(i) / dtime
+          d_sig_bnd2(i) = d_sig_bnd2(i) / dtime
+          d_sigmaw2(i) = d_sigmaw2(i) / dtime
+
+          d_dens_gen2(i) = d_dens_gen2(i) / dtime
+          d_dens_death2(i) = d_dens_death2(i) / dtime
+          d_dens_col2(i) = d_dens_col2(i) / dtime
+          d_dens_bnd2(i) = d_dens_bnd2(i) / dtime
+          d_awdens2(i) = d_awdens2(i) / dtime
+          d_wdens2(i) = d_wdens2(i) / dtime
         ENDIF
       ENDDO
-      IF (iflag_wk_pop_dyn == 3) THEN
-       DO i = 1, klon
+      IF (iflag_wk_pop_dyn >= 2) THEN
+        DO i = 1, klon
           IF (ok_qx_qw(i)) THEN
-        d_asig_death2(i)  = d_asig_death2(i)/dtime
-        d_asig_iicol2(i)  = d_asig_iicol2(i)/dtime
-        d_asig_aicol2(i)  = d_asig_aicol2(i)/dtime
-        d_asig_spread2(i) = d_asig_spread2(i)/dtime
-        d_asig_bnd2(i) = d_asig_bnd2(i)/dtime
+            d_adens_death2(i) = d_adens_death2(i) / dtime
+            d_adens_icol2(i) = d_adens_icol2(i) / dtime
+            d_adens_acol2(i) = d_adens_acol2(i) / dtime
+            d_adens_bnd2(i) = d_adens_bnd2(i) / dtime
           ENDIF
-       ENDDO
-      ENDIF ! (iflag_wk_pop_dyn == 3)  
-    ENDIF ! (iflag_wk_pop_dyn >= 2)  
-  ENDIF  ! (iflag_wk_pop_dyn >= 1)
- 
-!>jyg
-
-
-END SUBROUTINE wake
-
-SUBROUTINE wake_vec_modulation(nlon, nl, wk_adv, epsilon_loc, qb, d_qb, deltaqw, &
-    d_deltaqw, sigmaw, d_sigmaw, alpha)
-  ! ------------------------------------------------------
-  ! Dtermination du coefficient alpha tel que les tendances
-  ! corriges alpha*d_G, pour toutes les grandeurs G, correspondent
-  ! a une humidite positive dans la zone (x) et dans la zone (w).
-  ! ------------------------------------------------------
-  IMPLICIT NONE
-
-  ! Input
-  REAL qb(nlon, nl), d_qb(nlon, nl)
-  REAL deltaqw(nlon, nl), d_deltaqw(nlon, nl)
-  REAL sigmaw(nlon), d_sigmaw(nlon)
-  LOGICAL wk_adv(nlon)
-  INTEGER nl, nlon
-  ! Output
-  REAL alpha(nlon)
-  ! Internal variables
-  REAL zeta(nlon, nl)
-  REAL alpha1(nlon)
-  REAL x, a, b, c, discrim
-  REAL epsilon_loc
-  INTEGER i,k
-
-  DO k = 1, nl
-    DO i = 1, nlon
-      IF (wk_adv(i)) THEN
-        IF ((deltaqw(i,k)+d_deltaqw(i,k))>=0.) THEN
-          zeta(i, k) = 0.
-        ELSE
-          zeta(i, k) = 1.
-        END IF
-      END IF
-    END DO
-    DO i = 1, nlon
-      IF (wk_adv(i)) THEN
-        x = qb(i, k) + (zeta(i,k)-sigmaw(i))*deltaqw(i, k) + d_qb(i, k) + &
-          (zeta(i,k)-sigmaw(i))*d_deltaqw(i, k) - d_sigmaw(i) * &
-          (deltaqw(i,k)+d_deltaqw(i,k))
-        a = -d_sigmaw(i)*d_deltaqw(i, k)
-        b = d_qb(i, k) + (zeta(i,k)-sigmaw(i))*d_deltaqw(i, k) - &
-          deltaqw(i, k)*d_sigmaw(i)
-        c = qb(i, k) + (zeta(i,k)-sigmaw(i))*deltaqw(i, k) + epsilon_loc
-        discrim = b*b - 4.*a*c
-        ! PRINT*, 'x, a, b, c, discrim', x, a, b, c, discrim
-        IF (a+b>=0.) THEN !! Condition suffisante pour la positivite de ovap
-          alpha1(i) = 1.
-        ELSE
-          IF (x>=0.) THEN
+        ENDDO
+        IF (iflag_wk_pop_dyn == 3) THEN
+          DO i = 1, klon
+            IF (ok_qx_qw(i)) THEN
+              d_asig_death2(i) = d_asig_death2(i) / dtime
+              d_asig_iicol2(i) = d_asig_iicol2(i) / dtime
+              d_asig_aicol2(i) = d_asig_aicol2(i) / dtime
+              d_asig_spread2(i) = d_asig_spread2(i) / dtime
+              d_asig_bnd2(i) = d_asig_bnd2(i) / dtime
+            ENDIF
+          ENDDO
+        ENDIF ! (iflag_wk_pop_dyn == 3)
+      ENDIF ! (iflag_wk_pop_dyn >= 2)
+    ENDIF  ! (iflag_wk_pop_dyn >= 1)
+
+    !>jyg
+
+  END SUBROUTINE wake
+
+  SUBROUTINE wake_vec_modulation(nlon, nl, wk_adv, epsilon_loc, qb, d_qb, deltaqw, &
+          d_deltaqw, sigmaw, d_sigmaw, alpha)
+    ! ------------------------------------------------------
+    ! Dtermination du coefficient alpha tel que les tendances
+    ! corriges alpha*d_G, pour toutes les grandeurs G, correspondent
+    ! a une humidite positive dans la zone (x) et dans la zone (w).
+    ! ------------------------------------------------------
+    IMPLICIT NONE
+
+    ! Input
+    REAL qb(nlon, nl), d_qb(nlon, nl)
+    REAL deltaqw(nlon, nl), d_deltaqw(nlon, nl)
+    REAL sigmaw(nlon), d_sigmaw(nlon)
+    LOGICAL wk_adv(nlon)
+    INTEGER nl, nlon
+    ! Output
+    REAL alpha(nlon)
+    ! Internal variables
+    REAL zeta(nlon, nl)
+    REAL alpha1(nlon)
+    REAL x, a, b, c, discrim
+    REAL epsilon_loc
+    INTEGER i, k
+
+    DO k = 1, nl
+      DO i = 1, nlon
+        IF (wk_adv(i)) THEN
+          IF ((deltaqw(i, k) + d_deltaqw(i, k))>=0.) THEN
+            zeta(i, k) = 0.
+          ELSE
+            zeta(i, k) = 1.
+          END IF
+        END IF
+      END DO
+      DO i = 1, nlon
+        IF (wk_adv(i)) THEN
+          x = qb(i, k) + (zeta(i, k) - sigmaw(i)) * deltaqw(i, k) + d_qb(i, k) + &
+                  (zeta(i, k) - sigmaw(i)) * d_deltaqw(i, k) - d_sigmaw(i) * &
+                  (deltaqw(i, k) + d_deltaqw(i, k))
+          a = -d_sigmaw(i) * d_deltaqw(i, k)
+          b = d_qb(i, k) + (zeta(i, k) - sigmaw(i)) * d_deltaqw(i, k) - &
+                  deltaqw(i, k) * d_sigmaw(i)
+          c = qb(i, k) + (zeta(i, k) - sigmaw(i)) * deltaqw(i, k) + epsilon_loc
+          discrim = b * b - 4. * a * c
+          ! PRINT*, 'x, a, b, c, discrim', x, a, b, c, discrim
+          IF (a + b>=0.) THEN !! Condition suffisante pour la positivite de ovap
             alpha1(i) = 1.
           ELSE
-            IF (a>0.) THEN
-              alpha1(i) = 0.9*min( (2.*c)/(-b+sqrt(discrim)),  &
-                                   (-b+sqrt(discrim))/(2.*a) )
-            ELSE IF (a==0.) THEN
-              alpha1(i) = 0.9*(-c/b)
+            IF (x>=0.) THEN
+              alpha1(i) = 1.
             ELSE
-              ! PRINT*,'a,b,c discrim',a,b,c discrim
-              alpha1(i) = 0.9*max( (2.*c)/(-b+sqrt(discrim)),  &
-                                   (-b+sqrt(discrim))/(2.*a))
+              IF (a>0.) THEN
+                alpha1(i) = 0.9 * min((2. * c) / (-b + sqrt(discrim)), &
+                        (-b + sqrt(discrim)) / (2. * a))
+              ELSE IF (a==0.) THEN
+                alpha1(i) = 0.9 * (-c / b)
+              ELSE
+                ! PRINT*,'a,b,c discrim',a,b,c discrim
+                alpha1(i) = 0.9 * max((2. * c) / (-b + sqrt(discrim)), &
+                        (-b + sqrt(discrim)) / (2. * a))
+              END IF
             END IF
           END IF
-        END IF
-        alpha(i) = min(alpha(i), alpha1(i))
-      END IF
-    END DO
-  END DO
-
-
-END SUBROUTINE wake_vec_modulation
-
-
-
-SUBROUTINE pkupper(klon, klev, ptop, ph, p, pupper, kupper, &
-                    dth, hw_, rho, delta_t_min_in, &
-                    ktop, wk_adv, h_zzz, ptop1, ktop1)
-
-USE lmdz_wake_ini , ONLY: wk_pupper
-USE lmdz_wake_ini , ONLY: RG
-USE lmdz_wake_ini , ONLY: hwmin
-USE lmdz_wake_ini , ONLY: iflag_wk_new_ptop, wk_delta_t_min, wk_frac_int_delta_t
-USE lmdz_wake_ini , ONLY: wk_int_delta_t_min
-
-IMPLICIT NONE
-
-INTEGER,                              INTENT(IN) :: klon,klev
-REAL,       DIMENSION (klon,klev+1) , INTENT(IN) :: ph, p
-REAL,       DIMENSION (klon,klev+1) , INTENT(IN) :: rho
-LOGICAL,    DIMENSION (klon)        , INTENT(IN) :: wk_adv
-REAL,       DIMENSION (klon,klev+1) , INTENT(IN) :: dth
-REAL,                                 INTENT(IN) :: delta_t_min_in
-
-
-REAL,       DIMENSION (klon)  , INTENT(OUT)        :: hw_
-REAL,       DIMENSION (klon)  , INTENT(OUT)        :: ptop
-INTEGER,    DIMENSION (klon)  , INTENT(OUT)        :: Ktop
-REAL,       DIMENSION (klon)  , INTENT(OUT)        :: pupper
-INTEGER,    DIMENSION (klon)  , INTENT(OUT)        :: kupper
-REAL,       DIMENSION (klon)  , INTENT(OUT)        :: h_zzz       !!
-REAL,       DIMENSION (klon)  , INTENT(OUT)        :: Ptop1      !!
-INTEGER,    DIMENSION (klon)  , INTENT(OUT)        :: ktop1      !!
-
-INTEGER :: i,k
-
-LOGICAL,    DIMENSION (klon)       :: wk_active
-REAL                               :: delta_t_min
-REAL,     DIMENSION (klon)         :: dthmin
-REAL,     DIMENSION (klon)         :: ptop_provis,ptop_new
-REAL,     DIMENSION (klon)         :: z, dz
-REAL,     DIMENSION (klon)         :: sum_dth
-
-INTEGER,     DIMENSION (klon)                     :: k_ptop_provis
-REAL,     DIMENSION (klon)                     :: zk_ptop_provis
-REAL,     DIMENSION (klon)                        :: omega        !!
-REAL,     DIMENSION (klon,klev+1)                 :: int_dth      !! 
-REAL,     DIMENSION (klon,klev+1)                 :: dzz          !!
-REAL,     DIMENSION (klon,klev+1)                 :: zzz          !!
-REAL,     DIMENSION (klon)                 :: frac_int_dth          !!
-REAL                                              :: ddd!!
-
-
-INTEGER, SAVE :: ipas=0
-
-
-
-!INTEGER, SAVE :: compte=0
-
-! LJYF : a priori z, dz sum_dth sont aussi des variables internes
-! Les eliminer apres verification convergence numerique
-
-!compte=compte+1
-!PRINT*,'compte=',compte
+          alpha(i) = min(alpha(i), alpha1(i))
+        END IF
+      END DO
+    END DO
+
+  END SUBROUTINE wake_vec_modulation
+
+
+  SUBROUTINE pkupper(klon, klev, ptop, ph, p, pupper, kupper, &
+          dth, hw_, rho, delta_t_min_in, &
+          ktop, wk_adv, h_zzz, ptop1, ktop1)
+
+    USE lmdz_wake_ini, ONLY: wk_pupper
+    USE lmdz_wake_ini, ONLY: RG
+    USE lmdz_wake_ini, ONLY: hwmin
+    USE lmdz_wake_ini, ONLY: iflag_wk_new_ptop, wk_delta_t_min, wk_frac_int_delta_t
+    USE lmdz_wake_ini, ONLY: wk_int_delta_t_min
+
+    IMPLICIT NONE
+
+    INTEGER, INTENT(IN) :: klon, klev
+    REAL, DIMENSION (klon, klev + 1), INTENT(IN) :: ph, p
+    REAL, DIMENSION (klon, klev + 1), INTENT(IN) :: rho
+    LOGICAL, DIMENSION (klon), INTENT(IN) :: wk_adv
+    REAL, DIMENSION (klon, klev + 1), INTENT(IN) :: dth
+    REAL, INTENT(IN) :: delta_t_min_in
+
+    REAL, DIMENSION (klon), INTENT(OUT) :: hw_
+    REAL, DIMENSION (klon), INTENT(OUT) :: ptop
+    INTEGER, DIMENSION (klon), INTENT(OUT) :: Ktop
+    REAL, DIMENSION (klon), INTENT(OUT) :: pupper
+    INTEGER, DIMENSION (klon), INTENT(OUT) :: kupper
+    REAL, DIMENSION (klon), INTENT(OUT) :: h_zzz       !!
+    REAL, DIMENSION (klon), INTENT(OUT) :: Ptop1      !!
+    INTEGER, DIMENSION (klon), INTENT(OUT) :: ktop1      !!
+
+    INTEGER :: i, k
+
+    LOGICAL, DIMENSION (klon) :: wk_active
+    REAL :: delta_t_min
+    REAL, DIMENSION (klon) :: dthmin
+    REAL, DIMENSION (klon) :: ptop_provis, ptop_new
+    REAL, DIMENSION (klon) :: z, dz
+    REAL, DIMENSION (klon) :: sum_dth
+
+    INTEGER, DIMENSION (klon) :: k_ptop_provis
+    REAL, DIMENSION (klon) :: zk_ptop_provis
+    REAL, DIMENSION (klon) :: omega        !!
+    REAL, DIMENSION (klon, klev + 1) :: int_dth      !!
+    REAL, DIMENSION (klon, klev + 1) :: dzz          !!
+    REAL, DIMENSION (klon, klev + 1) :: zzz          !!
+    REAL, DIMENSION (klon) :: frac_int_dth          !!
+    REAL :: ddd!!
+
+    INTEGER, SAVE :: ipas = 0
+
+
+
+    !INTEGER, SAVE :: compte=0
+
+    ! LJYF : a priori z, dz sum_dth sont aussi des variables internes
+    ! Les eliminer apres verification convergence numerique
+
+    !compte=compte+1
+    !PRINT*,'compte=',compte
 
     ! Determine Ptop from buoyancy integral
